package com.felix.poc;

import java.util.ArrayList;
import java.util.Collection;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Set;

import org.jbpm.api.Configuration;

import org.jbpm.api.ExecutionService;

import org.jbpm.api.Execution;
import org.jbpm.api.ProcessEngine;
import org.jbpm.api.ProcessInstance;
import org.jbpm.api.RepositoryService;
import org.jbpm.api.activity.ActivityExecution;
import org.jbpm.api.model.OpenExecution;

public class MainDriver {

	public static ProcessInstance instnace;
	public static ExecutionService executionService = null;
	public static String id = null;

	/**
	 * @param args
	 */
	public static void main(String[] args) {

		// Build jBPM services
		ProcessEngine processEngine = new Configuration().setResource(
				"my.jbpm.cfg.xml").buildProcessEngine();

		RepositoryService repositoryService = processEngine
				.getRepositoryService();
		executionService = processEngine.getExecutionService();

		// Deploy helloWorld process definition and start a process instance .Where SubProc.jpdl.xml is the subprocess definition.
		String deploymentId = repositoryService.createDeployment()
				.addResourceFromClasspath("hello_world.jpdl.xml")
				.addResourceFromClasspath("checkAnalystAvailable.drl")
				.addResourceFromClasspath("SubProc.jpdl.xml").deploy();
		System.out.println("deploymentId==" + deploymentId);
		Set<AnalystFromDB> analysts = new HashSet<AnalystFromDB>();
		List list = new ArrayList();
		list.add("Felix");
		list.add("david");
		list.add("vijay");
		for (int j = 0; j < list.size(); j++) {
			if (list.get(j) == "Felix") {
				list.remove(j);
			}
			System.out.println(list.get(j));
		}
		for (int i = 0; i < 3; i++) {
			AnalystFromDB analystFromDB = new AnalystFromDB();
			analystFromDB.setAnalyst("FELIX");
			analystFromDB.setName("FELIX" + i);
			analystFromDB.setRegion("BELGIUM");
			analysts.add(analystFromDB);
		}
		Map<String, Object> vars = new HashMap<String, Object>();
		AnalystFinder analystFinder = new AnalystFinder();
		analystFinder.setAnalyst("FELIX");
		analystFinder.setAnalysts(analysts);
		analystFinder.setRegion("BELGIUM");
		vars.put("analystFinder", analystFinder);
		
		ProcessInstance processInstance = executionService
				.startProcessInstanceByKey("helloWorld", vars);

		processInstance.getId();
		
		System.out.println("TEST=================================");
		System.out.println(analystFinder.getAvailableAnalysts().size());
		Iterator<AnalystFromDB> iter = analystFinder.getAvailableAnalysts()
				.iterator();

		while (iter.hasNext()) {
			AnalystFromDB analystFromDB = iter.next();
			System.out.println(analystFromDB.getName());
		}
		System.out.println("=============FELIX=========="
				+ analystFinder.getAvailableAnalysts().toString());
				
		System.out.println(processInstance.findActiveActivityNames());
		System.out.println(processInstance.getParent());
		System.out.println(processInstance.getExecutions());
		//This will give the available executions.
		Collection ce = processInstance.getExecutions();
		Iterator iter1 = ce.iterator();
		while(iter1.hasNext())
		{
			OpenExecution openExecutio = (OpenExecution) iter1.next(); 			
			String idd= openExecutio.getId();			
			System.out.println("idd----"+idd);
		    System.out.println(	openExecutio.getSubProcessInstance());
		
		if(openExecutio.getSubProcessInstance()!= null)
		{
		System.out.println("----------------"+openExecutio.getSubProcessInstance().findActiveActivityNames());
		//This will give the sub process id (of SubProc.jpdl definition)
		String id = openExecutio.getSubProcessInstance().getId();
		System.out.println("----id===="+id);	
        //This should transition from 'printHelloWorld' to 'printHelloWorld1' state.		
		executionService.signalExecutionById(id,"printHelloWorld1");//The transition is happening but the below statement prints the ActiveActivity name as 'printHelloWorld'.
		System.out.println("----------------"+openExecutio.getSubProcessInstance().findActiveActivityNames());
		//So my doubt is how can I signal from one state to another in a subprocess instead of using executionService.signalExecutionById(id,"printHelloWorld1")..
		}
		}

		System.out.println(processInstance.findActiveActivityNames());
		System.out.println(processInstance.getParent());
		System.out.println(processInstance.getExecutions());
		
	}

}
